/*
 *	main.c
 *
 *	ɂ` AGAINST(ڐA)
 *
 *	* Tue Jan 30 23:36:15 JST 2007 Naoyuki Sawa
 *	- 1st [XB
 *	* Fri Feb 02 06:29:51 JST 2007 Naoyuki Sawa
 *	- Œ菬A܂B
 *	* Sat Feb 03 00:01:33 JST 2007 Naoyuki Sawa
 *	- ẽoOŁA폜ς݂̓G̃ɃANZXĂ܂ĂoOC܂B
 *	- XʉE֓Ƃɂ܂łłAvŽI[o[ŕsȓ蔻肪Ă̂C܂B
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#ifdef USE_MUSIC
#include "instdef2.c"
#endif /*USE_MUSIC*/

#ifdef USE_SOUND
const void* sound_table[SOUND_COUNT];
#endif /*USE_SOUND*/

#ifdef USE_TEXTURE
TEXTURE texture_table[TEXTURE_COUNT];
#endif /*USE_TEXTURE*/

#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT2
const SPRITE sprite_table[SPRITE_COUNT] = {
#include "sprite.h"
};
#undef SPRITE_
#endif /*USE_SPRITE*/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/*{{2007/07/23 P/EMU 48MHzΉΉ*/
	bP0_P0D_P07D = 1;
	/*}}2007/07/23 P/EMU 48MHzΉΉ*/

	/* B */
	app_init();

	/* C[vB */
	app_main();

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceAppSetProcPeriod(1000 / FPS);
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceLCDDispStart();
#ifdef QUICK_REPEAT
	pcePadSetTrigMode(PP_MODE_SINGLE);
#endif /*QUICK_REPEAT*/

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
#ifdef USE_3D
	surface.zbuff = zbuff;
	render_init_3d(&render, &surface, 0, 0, 0, 0, FRONT, BACK, FOVY);
#else /*USE_3D*/
	render_init_2d(&render, &surface, 0, 0, 0, 0);
#endif /*USE_3D*/

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(9/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef USE_UFE
	/* USBt@CVXeG~[VJn܂B */
	ufe_setup(9/*PCt@CT[oڑ҂()*/);
#endif /*USE_UFE*/

#ifdef RESOURCE_FNAME
	/* pext@CYt\[X擾܂B */
	resource = resource_address(RESOURCE_FNAME);
#endif /*RESOURCE_FNAME*/

#ifdef TURBO
	/* NbNEEFCgؑւ܂B */
	turbo(TURBO);
#endif /*TURBO*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_init();
#endif /*USE_GC*/

#ifdef USE_TCPIP
	/* TCP/IPvgRXC[gJn܂B */
	tcpip_start(0/*EthernethCoMobt@TCY()*/);
#endif /*USE_TCPIP*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_init(LDIRECT_INTERVAL);
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_MUSIC
	/* yCu܂B */
	music_loudness(1);
	loadInst(); /* uRandomism Zone(http://www8.plala.or.jp/randomism/)v́whFLbgver.2.10xgp */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

#ifdef USE_2BIT_ADPCM
	/* 2-bit ADPCM DecoderN܂B */
	adpcm_init(ADPCM_CHANNELS);
#endif /*USE_2BIT_ADPCM*/

	/* TEh܂B */
#ifdef USE_SOUND
	{
#define SOUND_(name) { extern const unsigned char name[]; sound_table[SND_##name] = name; }
#define SOUND_RESOURCE_(name,fname) { sound_table[SND_##name] = fpk_address(resource, fname, NULL); }
#include "sound.h"
#undef SOUND_
#undef SOUND_RESOURCE_
	}
#endif /*USE_SOUND*/

	/* eNX`܂B */
#ifdef USE_TEXTURE
	{
#define TEXTURE_(name) extern const unsigned char name[];
#define TEXTURE_RESOURCE_(name,fname) const void* const name = fpk_address(resource, fname, NULL);
#include "texture.h"
#undef TEXTURE_
#undef TEXTURE_RESOURCE_
		texture_table_init(texture_table, TEXTURE_COUNT,
#define TEXTURE_(name) name,
#define TEXTURE_RESOURCE_(name,fname) name,
#include "texture.h"
#undef TEXTURE_
#undef TEXTURE_RESOURCE_
		NULL/*Ō','z邽߂̃_~[Btexture_table_init()ɑ΂Ă͖ӖłB*/);
	}
#endif /*USE_TEXTURE*/

#ifdef USE_SPRITE
	/* ȈՃXvCghCo܂B */
	sprite_init(&render, sprite_table, SPRITE_COUNT, texture_table, TEXTURE_COUNT);
#endif /*USE_SPRITE*/

/*{{AvP[VL̏*/
	srand(pceTimerGetCount());
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
	music_loudness(0);
#endif /*USE_MUSIC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_free();
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_TCPIP
	/* TCP/IPvgRXC[gI܂B */
	tcpip_stop();
#endif /*USE_TCPIP*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_free();
#endif /*USE_GC*/

#ifdef USE_UFE
	/* USBt@CVXeG~[VI܂B */
	ufe_stop();
#endif /*USE_UFE*/
}

/****************************************************************************
 *	update
 ****************************************************************************/

/* * Mon Nov 06 17:37:17 JST 2006 Naoyuki Sawa
 * - schedule()AʍXV𕪗܂B
 *   t[҂ʍXVsꍇ́Å֐ĂяoĂB
 */
void
update()
{
#ifdef V_SCREEN
	/* vbuff(c)_def_vbuff()ϊ */
	unsigned char *dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
	unsigned char *src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
	int x, y;
	for(x = DISP_X - 1; x >= 0; x--) {
		for(y = 0; y < DISP_Y; y++) {
			*dst = *src;
			dst += 1;      /* ʂEɑ܂ */
			src += DISP_X; /* cʂɑ܂ */
		}
		                            /* ʂ͊Ɏ̍sֈړĂ܂ */
		src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
	}
#endif /*V_SCREEN*/

	/* ʓ] */
	pceLCDTrans();
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

/* * Fri Dec 15 00:49:15 JST 2006 Naoyuki Sawa
 * - schedule()֐ɁATEh|[YΉR[hǉ܂B
 *   ł͏肭삵Ă悤łAX[v̕Aɖ肪NȂmFłB
 * - A|[YԂ̂܂܁AȂ킿ATEh|[YԂ̂܂܂ŃAvP[VIĂ܂ꍇɂA
 *   CLiPCupceAppExit()pceWaveStop(1)ĂяoĂATEhԂZbĝŁAvłB
 */

void
schedule()
{
#ifdef USE_PAUSE
	{
		/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
		 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
		 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
		 */
		//unsigned char save[PAUSE_H][PAUSE_W];
		unsigned char (*save)[PAUSE_W] = NULL/*x}*/;
		int pause = 0;
		/*{{2006/12/15:TEh|[YΉ*/
		int sound_pause = 0/*x}*/;
		/*}}2006/12/15:TEh|[YΉ*/
		int x, y;
		for(;;) {
#endif /*USE_PAUSE*/
			update();		/* ʍXV */
			yield();		/* VXe */
			joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
			joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
				       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
				| (joy & PAD_LF ? PAD_UP : 0)
				| (joy & PAD_RI ? PAD_DN : 0)
				| (joy & PAD_UP ? PAD_RI : 0)
				| (joy & PAD_DN ? PAD_LF : 0)
				| (joy & TRG_LF ? TRG_UP : 0)
				| (joy & TRG_RI ? TRG_DN : 0)
				| (joy & TRG_UP ? TRG_RI : 0)
				| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

#ifdef USE_PAUSE
			/* PAUSEB */
			if(joy & TRG_START) {
				pause = !pause;	/* PAUSEԐ؂ւ */
				if(pause) {	/* PAUSE IN */
					/*{{2006/12/15:TEh|[YΉ*/
					ENTER_CS;
					sound_pause = fINT_EDMA.EHDM1;
					if(sound_pause) {
						fINT_EDMA.EHDM1 = 0;
					}
					LEAVE_CS;
					/*}}2006/12/15:TEh|[YΉ*/
					/* PAUSEbZ[W\̃C[WޔB */
					save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
					if(save == NULL) DIE();
					for(y = 0; y < PAUSE_H; y++) {
						for(x = 0; x < PAUSE_W; x++) {
							save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
						}
					}
				} else {	/* PAUSE OUT */
					/*{{2006/12/15:TEh|[YΉ*/
					ENTER_CS;
					if(sound_pause) {
						fINT_EDMA.EHDM1 = 1;
					}
					LEAVE_CS;
					/*}}2006/12/15:TEh|[YΉ*/
					/* PAUSEbZ[W\̃C[W𕜋AB */
					for(y = 0; y < PAUSE_H; y++) {
						for(x = 0; x < PAUSE_W; x++) {
							vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
						}
					}
					free(save); /* C[Wޔpobt@J */
				}
			}
			if(!pause) break;

			/* PAUSEbZ[W_ŕ\B */
			if(pceTimerGetCount() % 1000 < 750) {
				render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
			} else {
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
			}
		}
	}
#endif /*USE_PAUSE */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	{
		static unsigned char rep[8]; /* I[gs[gJE^ */
		int i, mask;
		for(i = 0; i < 8; i++) {
			mask = 1 << i; /* PAD_* */
			if(QUICK_REPEAT_PADS & mask) {
				if(joy & mask) {
					if(rep[i] != 0xff) rep[i]++;
					if(rep[i] >= QUICK_REPEAT_DELAY) joy |= mask << 8; /* TRG_* */
				} else {
					rep[i] = 0;
				}
			}
		}
	}
#endif QUICK_REPEAT

	now++;	/* O[o^C}XV */
}

/****************************************************************************
 *	delay
 ****************************************************************************/

void
delay(int frame)
{
	while(frame > 0) {
		schedule();
		frame--;
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

const ENEMY_SPEC enemy_spec[] = {
	{ fld( 0.0),  0,   0,  0 },	// (gp)
	{ fld( 8.0),  0, 300,  0 },	// e
	{ fld(16.0),  5, 500,  1 },	// jW
	{ fld( 8.0),  0, 300,  0 },	// |bL[
	{ fld(16.0),  5, 500,  1 },	// 卪
	{ fld(24.0),  5, 600, 10 },	// Ȃ
	{ fld(24.0),  5, 600, 10 },	// Ă
	{ fld(24.0), 15, 600,  0 },	// 5
	{ fld(48.0), 40, 600,  0 },	// X
	{ fld(48.0), 30, 600, 50 },	// 
	{ fld(48.0), 30, 600, 80 },	// v
};

/****************************************************************************
 *	app_main
 ****************************************************************************/

void
app_main()
{
	sprite_draw(0, 0, SPR_BG, DRW_NOMAL);
	memcpy(bgbuff, vbuff, DISP_X * DISP_Y);

	InitializeListHead(&enemy_list);
	InitializeListHead(&threnemy_list);
	InitializeListHead(&effect_list);

	// P/ECEłł͍ŏ1010Ԓn܂őI\ɂ܂B
	levelmax = 99;

	stategameinit();
	state = STATE_TITLE_INIT;
	mainloop();
}

/****************************************************************************
 *	ds_play
 ****************************************************************************/

void
ds_play(int no)
{
	sound_play(no, sound_table[no], 1);
}

/****************************************************************************
 *	gcopy
 ****************************************************************************/

void
gcopy(int spr, fixed x, fixed y)
{
	fmul_(x, fld(128.0 / 640.0));
	fmul_(y, fld( 88.0 / 480.0));

	sprite_draw(fist(x), fist(y), spr, DRW_NOMAL);
}

/****************************************************************************
 *	grotate
 ****************************************************************************/

void
grotate(int spr, fixed x, fixed y, fixed r)
{
	int i;

	fmul_(x, fld(128.0 / 640.0));
	fmul_(y, fld( 88.0 / 480.0));

	fadd_(r, fld(M_PI2 / 32 / 2));
	fmul_(r, fld(32 / M_PI2    ));
	i = fist(r);
	i &= 31;
	spr += i;

	sprite_draw(fist(x), fist(y), spr, DRW_NOMAL);
}

/****************************************************************************
 *	RND_PI2
 ****************************************************************************/

fixed
RND_PI2()
{
	return FRND_RANGE(seed, fchs(PI), PI);
}

/****************************************************************************
 *	ROUND_PI2
 ****************************************************************************/

fixed
ROUND_PI2(fixed r)
{
	while(fcom(r, < , fchs(PI))) fadd_(r, PI2);
	while(fcom(r, >=,      PI )) fsub_(r, PI2);
	return r;
}

/****************************************************************************
 *	mainloop
 ****************************************************************************/

void
mainloop()
{
	int debug = 0;

	for(;;) {
		schedule();

		// BR}hA\tgEGAZbgAI
		if(joy & TRG_SELECT) {
			if(joy & PAD_A) {
				mychar.life = MYCHAR_LIFE_MAX; // A+SEL:CtS(BR}h)
			} else if(joy & PAD_B) {
				debug = !debug; // B+SEL:fobO[hؑ(BR}h)
			} else {
				if(state != STATE_TITLE) {
					state = STATE_TITLE_INIT; // Q[SEL:\tgEFAZbg
				} else {
					break; // ^CgʂSEL:I
				}
			}
		}

		// eԂs
		drawback();
		switch(state) {
		case STATE_TITLE_INIT: statetitleinit(); break;
		case STATE_TITLE:      statetitle();     break;
		case STATE_GAME_INIT:  stategameinit();  break;
		case STATE_GAME:       stategame();      break;
		case STATE_OVER_INIT:  stateoverinit();  break;
		case STATE_OVER:       stateover();      break;
		}
		drawstatus();
		if(debug) debugstatus(); // fobOp

		//{{---
		// t[
		//int t = list_size((LIST*)&enemy_list); // G̑
		//REPEAT_EFFECT()
		//	if(effect->type == EFFECT_TYPE_BANANA) {
		//		t += 2; // ΂Ȃx2
		//	}
		//LOOP_EFFECT()
		//// (G̑)(΂Ȃx2)臒lz邩A~Xƃobg^C
		//if((state == STATE_GAME) &&
		//   ((t > BULLETTIME) || mychar.dam_timer)) {
		//	// obg^C
		//} else {
		//	// ʏ
		//}
		//IWił́Â悤ȏ30fps->20fps̃X[Ă܂A
		//P/ECE͂Gƕ`悪Ԃɍ킸X[ɂȂĂ܂܂B
		//ŒPɁA~X30fps->15fps̃X[邱Ƃɂ܂B
		if((state == STATE_GAME) && mychar.dam_timer) {
			yield();
		}
		//}}---
	}
}

/****************************************************************************
 *	statetitleinit
 ****************************************************************************/

void
statetitleinit()
{
	state = STATE_TITLE;

	play_timer = 0;
	level = 0;
}

/****************************************************************************
 *	statetitle
 ****************************************************************************/

void
statetitle()
{
	int retval;
	int i;
	int color;
	int param;
	int x;
	int y;
	int spr;

	x = 64 - 30;
	y = 36 - 10;
	sprite_draw(x, y, SPR_TITLE, DRW_NOMAL);

	for(i = 0; i < 2; i++) {
		color = i ? 2 : 1;
		param = DRW_CLR(color, COLOR_MASK);

		x = 35 - i;
		y = 50 - i;

		/* `ƏZ */
		spr = SPR_STARTJYUSHO;
		sprite_draw(x, y, spr, param);
		x += sprite_table[spr].w;
		x += 1;

		/* : */
		retval = render_printf(&render, x, y, 2, color, ":");
		x += LOHALF(retval);

		/* ? */
		retval = render_printf(&render, x, y, 2, color, "%d", level / 10 + 1);
		x += LOHALF(retval);

		/*  */
		spr = SPR_CHOME;
		sprite_draw(x, y, spr, param);
		x += sprite_table[spr].w;
		x += 1;

		/* ? */
		retval = render_printf(&render, x, y, 2, color, "%d", level % 10 + 1);
		x += LOHALF(retval);

		/* Ԓn */
		spr = SPR_BANTI;
		sprite_draw(x, y, spr, param);
	}

	if(play_timer > 1) {
		// Jnx
		if(joy & TRG_LF) level--;
		if(joy & TRG_RI) level++;
		if(joy & TRG_UP) level -= 10;
		if(joy & TRG_DN) level += 10;
		if(level <        0) level =        0;
		if(level > levelmax) level = levelmax;

		// Q[Jn
		if(joy & TRG_A) state = STATE_GAME_INIT;
	}
	play_timer++;
}

/****************************************************************************
 *	stategameinit
 ****************************************************************************/

void
stategameinit()
{
	memset(&mychar, 0, sizeof(MYCHAR));
	mychar.x = fld(320.0);
	mychar.y = fld(240.0);
	mychar.life = MYCHAR_LIFE_MAX;

	memset(&anchor, 0, sizeof(ANCHOR));
	anchor.state = ANCHOR_STATE_STANDBY;

	memset(&grab_enemy, 0, sizeof(GRAB_ENEMY));

	REPEAT_ENEMY()
		delenemy(enemy);
	LOOP_ENEMY()
	REPEAT_THRENEMY()
		delthrenemy(threnemy);
	LOOP_THRENEMY()
	REPEAT_EFFECT()
		deleffect(effect);
	LOOP_EFFECT();

	play_timer = 0;
	score = 0;
	banana_score = 0;
	/*{{2007/02/03*/
	tamakesi_flag = 0;
	/*}}2007/02/03*/

	state = STATE_GAME;
}

/****************************************************************************
 *	stategame
 ****************************************************************************/

void
stategame()
{
	play_timer++;

	movemychar();
	moveanchor();
	moveenemy();
	collisionenemy();
	/*{{2007/02/03*/
	tamakesi();
	/*}}2007/02/03*/

	drawbanana();
	drawchain();
	drawenemy();
	movedraweffect();
	drawmychar();

	geneenemy();

	if(!(play_timer % 400)) level++;

	if(score > hiscore) hiscore = score;
	if(banana_score > banana_hiscore) banana_hiscore = banana_score;

	if(mychar.life < 0) state = STATE_OVER_INIT;
}

/****************************************************************************
 *	stateoverinit
 ****************************************************************************/

void
stateoverinit()
{
	state = STATE_OVER;
	over_timer = 0;

	if(level > levelmax) levelmax = level;

	addeffect(
		mychar.x,
		mychar.y,
		fld(0.0),
		fld(0.0),
		RND_PI2(),
		fld(64.0),
		EFFECT_TYPE_PERTIC1);
	addeffect(
		mychar.x,
		mychar.y,
		fld(0.0),
		fld(0.0),
		RND_PI2(),
		fld(384.0),
		EFFECT_TYPE_RING);
	addpertics(
		mychar.x,
		mychar.y,
		fld(64.0),
		fld(32.0),
		fld(0.0),
		fld(0.0),
		15);
	ds_play(SND_EXPLODE2);
}

/****************************************************************************
 *	stateover
 ****************************************************************************/

void
stateover()
{
	int retval;
	int i;
	int color;
	int param;
	int x;
	int y;
	int spr;
	int tmp;

	moveenemy();
	collisionenemy();
	/*{{2007/02/03*/
	tamakesi();
	/*}}2007/02/03*/

	drawbanana();
	drawenemy();
	movedraweffect();

	play_timer++;

	over_timer++;
	if(over_timer > 30) {
		if(joy & TRG_A) state = STATE_TITLE_INIT;
	}

	for(i = 0; i < 2; i++) {
		color = i ? 2 : 1;
		param = DRW_CLR(color, COLOR_MASK);

		x = 37 - i;
		y = 36 - i;

		/* `ށ`΁` */
		spr = SPR_GAMEOVER;
		sprite_draw(x, y, spr, param);

		x = 51 - i;
		y = 53 - i;

		tmp = level / 10 + 1; while(tmp >= 10) { tmp /= 10; x -= 2; }
		tmp = level % 10 + 1; while(tmp >= 10) { tmp /= 10; x -= 2; }

		/* ? */
		retval = render_printf(&render, x, y, 2, color, "%d", level / 10 + 1);
		x += LOHALF(retval);

		/*  */
		spr = SPR_CHOME;
		sprite_draw(x, y, spr, param);
		x += sprite_table[spr].w;
		x += 1;

		/* ? */
		retval = render_printf(&render, x, y, 2, color, "%d", level % 10 + 1);
		x += LOHALF(retval);

		/* Ԓn */
		spr = SPR_BANTI;
		sprite_draw(x, y, spr, param);

		x = 34 - i;
		y = 59 - i;

		tmp =        score; while(tmp >= 10) { tmp /= 10; x -= 2; }
		tmp = banana_score; while(tmp >= 10) { tmp /= 10; x -= 2; }

		/*  */
		spr = SPR_OYATUDAI;
		sprite_draw(x, y, spr, param);
		x += sprite_table[spr].w;
		x += 1;

		/* ??? */
		retval = render_printf(&render, x, y, 2, color, "%d", score);
		x += LOHALF(retval);

		/* ~ */
		spr = SPR_YEN;
		sprite_draw(x, y, spr, param);
		x += sprite_table[spr].w;
		x += 1;

		/* / */
		retval = render_printf(&render, x, y, 2, color, "/");
		x += LOHALF(retval);

		/* ΂Ȃȑ */
		spr = SPR_BANANADAI;
		sprite_draw(x, y, spr, param);
		x += sprite_table[spr].w;
		x += 1;

		/* ??? */
		retval = render_printf(&render, x, y, 2, color, "%d", banana_score);
		x += LOHALF(retval);

		/* ~ */
		spr = SPR_YEN;
		sprite_draw(x, y, spr, param);
	}
}

/****************************************************************************
 *	addenemy
 ****************************************************************************/

// ʏGǉ
// xx  - Wx
// yy  - @@y
// sxx - xx
// syy - @@y
// rot - 
// tp  - G^Cv
void
addenemy(fixed xx, fixed yy, fixed sxx, fixed syy, fixed rot, int tp)
{
	static POOL enemy_pool = { sizeof(ENEMY) };
	//
	ENEMY* enemy = pool_alloc(&enemy_pool);
	InsertTailList(&enemy_list, &enemy->list_entry);

	enemy->type = tp;
	enemy->x = xx;
	enemy->y = yy;
	enemy->sx = sxx;
	enemy->sy = syy;
	enemy->rotate = rot;
	enemy->life = enemy_spec[tp].life;
}

/****************************************************************************
 *	delenemy
 ****************************************************************************/

void
delenemy(ENEMY* enemy)
{
	RemoveEntryList(&enemy->list_entry);
	memset(enemy, 0, sizeof(ENEMY));
	pool_free(enemy);
}

/****************************************************************************
 *	addthrenemy
 ****************************************************************************/

// Gǉ
// xx  - Wx
// yy  - @@y
// sxx - xx
// syy - @@y
// rrr - 
// tp  - G^Cv
// lf  - GCt
void
addthrenemy(fixed xx, fixed yy, fixed sxx, fixed syy, fixed rrr, int tp, int lf)
{
	static POOL threnemy_pool = { sizeof(THRENEMY) };
	//
	THRENEMY* threnemy = pool_alloc(&threnemy_pool);
	InsertTailList(&threnemy_list, &threnemy->list_entry);

	threnemy->type = tp;
	threnemy->x = xx;
	threnemy->y = yy;
	threnemy->sx = sxx;
	threnemy->sy = syy;
	threnemy->rotate = rrr;
	threnemy->life = lf;
}

/****************************************************************************
 *	delthrenemy
 ****************************************************************************/

void
delthrenemy(THRENEMY* threnemy)
{
	RemoveEntryList(&threnemy->list_entry);
	memset(threnemy, 0, sizeof(THRENEMY));
	pool_free(threnemy);
}

/****************************************************************************
 *	addeffect
 ****************************************************************************/

// GtFNgǉ
// xx  - Wx
// yy  - @@y
// sxx - xx
// syy - @@y
// rrr - 
// szz - TCY
// tp  - G^Cv
void
addeffect(fixed xx, fixed yy, fixed sxx, fixed syy, fixed rrr, fixed szz, int tp)
{
	static POOL effect_pool = { sizeof(EFFECT) };
	//
	EFFECT* effect = pool_alloc(&effect_pool);
	InsertTailList(&effect_list, &effect->list_entry);

	effect->type = tp;
	effect->x = xx;
	effect->y = yy;
	effect->sx = sxx;
	effect->sy = syy;
	effect->rotate = rrr;
	effect->size = szz;
}

/****************************************************************************
 *	deleffect
 ****************************************************************************/

void
deleffect(EFFECT* effect)
{
	RemoveEntryList(&effect->list_entry);
	memset(effect, 0, sizeof(EFFECT));
	pool_free(effect);
}

/****************************************************************************
 *	addpertics
 ****************************************************************************/

// p[eBNĂƁ[ɔ΂(EFFECT_TYPE_PERTIC1_ɔ΂)
// xx  - Wx
// yy  - @@y
// spp - x(XJ[l)
// szz - TCY
// sxx - xx
// syy - @@y
// num - 
void
addpertics(fixed xx, fixed yy, fixed spp, fixed szz, fixed sxx, fixed syy, int numm)
{
	int i;
	fixed vx;
	fixed vy;
	fixed sz;

	for(i = 0; i < numm; i++) {
		vx = FRND_RANGE(seed, fld(-1.0), fld(1.0));
		vy = FRND_RANGE(seed, fld(-1.0), fld(1.0));
		sz = FRND_RANGE(seed, fld( 0.0), fld(1.0));
		addeffect(
			xx,
			yy,
			fadd(fmul(fmul(vx, sz), spp), sxx),
			fadd(fmul(fmul(vy, sz), spp), syy),
			RND_PI2(),
			fmul(fsub(fld(1.0), fmul(sz, fld(0.8))), szz),
			EFFECT_TYPE_PERTIC1);
	}
}

/****************************************************************************
 *	destroypertics
 ****************************************************************************/

// GԂEƂ
// xx  - Wx
// yy  - @@y
// sxx - xx
// syy - @@y
// tp  - G^Cv
void
destroypertics(fixed xx, fixed yy, fixed sxx, fixed syy, int tp)
{
	int i;
	fixed rr;

	if(tp < ENEMY_TYPE_ZAKO1) {
		// en
		addeffect(
			xx,
			yy,
			sxx,
			syy,
			RND_PI2(),
			fld(32.0),
			EFFECT_TYPE_PERTIC1);
		addpertics(
			xx,
			yy,
			fld(32.0),
			fld(32.0),
			sxx,
			syy,
			3);
		ds_play(SND_EXPLODE0);
	} else {
		// UR/^
		addeffect(
			xx,
			yy,
			sxx,
			syy,
			RND_PI2(),
			fld(64.0),
			EFFECT_TYPE_PERTIC1);
		addpertics(
			xx,
			yy,
			fld(64.0),
			fld(32.0),
			sxx,
			syy,
			15);

		if(tp < ENEMY_TYPE_BOX2) {
			// UR
			ds_play(SND_EXPLODE1);
		} else {
			// ^
			ds_play(SND_EXPLODE2);
			addeffect(
				xx,
				yy,
				sxx,
				syy,
				RND_PI2(),
				fld(384.0),
				EFFECT_TYPE_RING);
			i = RND32(seed) & 1; /* i=0 or 1 */
			do {
				rr = RND_PI2();
				addeffect(
					fadd(xx, fmul(fld(192.0), fcos(rr))),
					fadd(yy, fmul(fld(192.0), fsin(rr))),
					sxx,
					syy,
					rr,
					fld(128.0),
					EFFECT_TYPE_LINE);
			} while(i--); /* i=0Ȃ1A1Ȃ2 */
			//// e
			//REPEAT_ENEMY()
			//	if(enemy->type < ENEMY_TYPE_ZAKO1) {
			//		addeffect(
			//			enemy->x,
			//			enemy->y,
			//			fmul(fld(RND32_RANGE(seed, 0-5, 9-5)), fld(0.2)),
			//			fmul(fld(RND32_RANGE(seed, 0-5, 3-5)), fld(0.2)),
			//			fld(0.0),
			//			fld(0.0),
			//			EFFECT_TYPE_BANANA);
			//		banana_score++;
			//		delenemy(enemy);
			//	}
			//LOOP_ENEMY()
			//* Sat Feb 03 00:00:42 JST 2007 Naoyuki Sawa
			//- ŒesĂ͂܂!!
			//  moveenemy()collisionenemy()REPEAT_ENEMY()`LOOP_ENEMY()Ă΂ꂽƂɁAdelenemy()Ă܂ƁA
			//  ܂܌Ăяoŏ̎ENEMYdelenemy()ꍇɁA폜͂ENEMYɃANZXĂ܂łB
			//  ł͒eKvł邱Ƃ}[NĂɂāAetamakesi()ɕ邱Ƃɂ܂B
			//  (̃oÓAP/ECEڐAœL̂̂łBIWił́AXgł͂ȂzŊǗĂ̂ŁA肠܂B)
			tamakesi_flag = 1;
		}
	}
}

/*{{2007/02/03*/
void
tamakesi()
{
	if(tamakesi_flag) {
		tamakesi_flag = 0;
		// e
		REPEAT_ENEMY()
			if(enemy->type < ENEMY_TYPE_ZAKO1) {
				addeffect(
					enemy->x,
					enemy->y,
					fmul(fld(RND32_RANGE(seed, 0-5, 9-5)), fld(0.2)),
					fmul(fld(RND32_RANGE(seed, 0-5, 3-5)), fld(0.2)),
					fld(0.0),
					fld(0.0),
					EFFECT_TYPE_BANANA);
				banana_score++;
				delenemy(enemy);
			}
		LOOP_ENEMY()
	}
}
/*}}2007/02/03*/

/****************************************************************************
 *	addscore
 ****************************************************************************/

// XRAZ
// sscore - XRA
void
addscore(int sscore)
{
	score += sscore;
}

/****************************************************************************
 *	drawback
 ****************************************************************************/

void
drawback()
{
	memcpy(vbuff, bgbuff, DISP_X * DISP_Y);
}

/****************************************************************************
 *	drawstatus
 ****************************************************************************/

void
drawstatus()
{
	int retval;
	int i;
	int color;
	int param;
	int x;
	int y;
	int spr;
	int t;
	int tmp;

	for(i = 0; i < 2; i++) {
		color = i ? 2 : 0;
		param = DRW_CLR(color, COLOR_MASK);

		x = 1 - i;
		y = 1 - i;

		/* Ђ邢Ȃ */
		spr = SPR_HIRUINAKI;
		sprite_draw(x, y, spr, param);
		x += sprite_table[spr].w;

		/* E */
		render_point(&render, x + 1, y + 2, color);
		x += 3;

		/*  */
		spr = SPR_OYATUDAI;
		sprite_draw(x, y, spr, param);
		x += sprite_table[spr].w;
		x += 1;

		/* ??? */
		retval = render_printf(&render, x, y, 2, color, "%d", hiscore);
		x += LOHALF(retval);

		/* ~ */
		spr = SPR_YEN;
		sprite_draw(x, y, spr, param);
		x += sprite_table[spr].w;
		x += 1;

		/* / */
		retval = render_printf(&render, x, y, 2, color, "/");
		x += LOHALF(retval);

		/* ΂Ȃȑ */
		spr = SPR_BANANADAI;
		sprite_draw(x, y, spr, param);
		x += sprite_table[spr].w;
		x += 1;

		/* ??? */
		retval = render_printf(&render, x, y, 2, color, "%d", banana_hiscore);
		x += LOHALF(retval);

		/* ~ */
		spr = SPR_YEN;
		sprite_draw(x, y, spr, param);

		color = i ? 1 : 3;
		param = DRW_CLR(color, COLOR_MASK);

		x = 1 - i;
		y = DISP_Y - 11 - i;

		/* ? */
		retval = render_printf(&render, x, y, 2, color, "%d", level / 10 + 1);
		x += LOHALF(retval);

		/*  */
		spr = SPR_CHOME;
		sprite_draw(x, y, spr, param);
		x += sprite_table[spr].w;
		x += 1;

		/* ? */
		retval = render_printf(&render, x, y, 2, color, "%d", level % 10 + 1);
		x += LOHALF(retval);

		/* Ԓn */
		spr = SPR_BANTI;
		sprite_draw(x, y, spr, param);

		x = 1 - i;
		y = DISP_Y - 5 - i;

		/*  */
		spr = SPR_OYATUDAI;
		sprite_draw(x, y, spr, param);
		x += sprite_table[spr].w;
		x += 1;

		/* ??? */
		retval = render_printf(&render, x, y, 2, color, "%d", score);
		x += LOHALF(retval);

		/* ~ */
		spr = SPR_YEN;
		sprite_draw(x, y, spr, param);
		x += sprite_table[spr].w;
		x += 1;

		/* / */
		retval = render_printf(&render, x, y, 2, color, "/");
		x += LOHALF(retval);

		/* ΂Ȃȑ */
		spr = SPR_BANANADAI;
		sprite_draw(x, y, spr, param);
		x += sprite_table[spr].w;
		x += 1;

		/* ??? */
		retval = render_printf(&render, x, y, 2, color, "%d", banana_score);
		x += LOHALF(retval);

		/* ~ */
		spr = SPR_YEN;
		sprite_draw(x, y, spr, param);
	}

	t = 0;
	REPEAT_EFFECT()
		if(effect->type == EFFECT_TYPE_BANANA) t++;
	LOOP_EFFECT()
	if(t) {
		for(i = 0; i < 2; i++) {
			color = i ? (play_timer & 1) : 3;
			param = DRW_CLR(color, COLOR_MASK);

			x = DISP_X - 9 - i;
			y = DISP_Y - 5 - i;

			tmp = t; while(tmp >= 10) { tmp /= 10; x -= 4; }

			/* ??? */
			retval = render_printf(&render, x, y, 2, color, "%d", t);
			x += LOHALF(retval);

			/* ~ */
			spr = SPR_YEN;
			sprite_draw(x, y, spr, param);
		}
	}
}

/****************************************************************************
 *	debugstatus
 ****************************************************************************/

void
debugstatus()
{
	int x;
	int y;

	x = DISP_X - 25;
	y = DISP_Y - 21;
	render_printf_framed(&render, x, y, 2, 0x220, "ENE%3d", list_size((LIST*)&enemy_list));
	y += 7;
	render_printf_framed(&render, x, y, 2, 0x220, "THR%3d", list_size((LIST*)&threnemy_list));
	y += 7;
	render_printf_framed(&render, x, y, 2, 0x220, "EFF%3d", list_size((LIST*)&effect_list));
}

/****************************************************************************
 *	movemychar
 ****************************************************************************/

void
movemychar()
{
	fixed vx;
	fixed vy;
	fixed vr;

	// @֌W---------------------
	// Ct
	if(mychar.life < MYCHAR_LIFE_MAX) {
		mychar.life++;
	}

	// ړ
	vx = fld(0.0);
	vy = fld(0.0);
	if(joy & PAD_LF) { vx = fld(-1.0); fsub_(mychar.gr_rotate, MYCHAR_ROT); }
	if(joy & PAD_UP) { vy = fld(-1.0); fsub_(mychar.gr_rotate, MYCHAR_ROT); }
	if(joy & PAD_RI) { vx = fld( 1.0); fadd_(mychar.gr_rotate, MYCHAR_ROT); }
	if(joy & PAD_DN) { vy = fld( 1.0); fadd_(mychar.gr_rotate, MYCHAR_ROT); }
	if(vx || vy) {
		vr = fsqrt(fadd(fmul(vx, vx), fmul(vy, vy)));
		if(vr) {
			fdiv_(vx, vr);
			fdiv_(vy, vr);
		}
		if(((anchor.state == ANCHOR_STATE_STANDBY) || (anchor.state == ANCHOR_STATE_RETURN)) && !(joy & PAD_B)) {
			fadd_(mychar.ssx, fmul(vx, MYCHAR_SPEED1));
			fadd_(mychar.ssy, fmul(vy, MYCHAR_SPEED1));
		} else {
			fadd_(mychar.ssx, fmul(vx, MYCHAR_SPEED2));
			fadd_(mychar.ssy, fmul(vy, MYCHAR_SPEED2));
		}
	}

	// ƌ
	fadd_(mychar.x, fadd(mychar.sx, mychar.ssx));
	fadd_(mychar.y, fadd(mychar.sy, mychar.ssy));

	fmul_(mychar.ssx, MYCHAR_SPWEAKEN);
	fmul_(mychar.ssy, MYCHAR_SPWEAKEN);
	fmul_(mychar.sx, MYCHAR_REACTWEAKEN);
	fmul_(mychar.sy, MYCHAR_REACTWEAKEN);
	fmul_(mychar.gr_rotate, MYCHAR_ROTWEAKEN);

	if(fcom(mychar.x, <, fld(        32.0))) mychar.x = fld(        32.0);
	if(fcom(mychar.x, >, fld(640.0 - 32.0))) mychar.x = fld(640.0 - 32.0);
	if(fcom(mychar.y, <, fld(        32.0))) mychar.y = fld(        32.0);
	if(fcom(mychar.y, >, fld(480.0 - 32.0))) mychar.y = fld(480.0 - 32.0);

	// GƂ̃RW(Փ˔)-----------------------
	REPEAT_ENEMY()
		vx = fsub(mychar.x, enemy->x);
		vy = fsub(mychar.y, enemy->y);
		vr = fadd(MYCHAR_SIZE, enemy_spec[enemy->type].size);
		if(fcom(fadd(fmul(vx, vx), fmul(vy, vy)), <, fmul(vr, vr))) {
			// H
			if(mychar.dam_timer) {
				mychar.life -= fist(fimul(MYCHAR_DAMAGE, enemy_spec[enemy->type].dam));
			} else {
				mychar.life -=                           enemy_spec[enemy->type].dam  ;
			}
			mychar.dam_timer = MYCHAR_DAM_TIME;
			//{{---
			//vr = sqrt(vx * vx + vy * vy);
			//̂悤ɌvẐƎv̂łA
			//̌vZ@ŃQ[oXĂ܂B
			vr = fsqrt(vr);
			//}}---
			if(vr) {
				fdiv_(vx, vr);
				fdiv_(vy, vr);
			}
			mychar.sx = fmul(MYCHAR_DAM_SP, vx);
			mychar.sy = fmul(MYCHAR_DAM_SP, vy);

			if(anchor.state == ANCHOR_STATE_GRAB) {
				// ͂ł͓̂
				anchor.state = ANCHOR_STATE_RETURN;
				vx = fidiv(anchor.sx, 2);
				vy = fidiv(anchor.sy, 2);
				addthrenemy(
					grab_enemy.x,
					grab_enemy.y,
					vx,
					vy,
					grab_enemy.rotate,
					grab_enemy.type,
					grab_enemy.life);
			}

			// GɃ_[W
			enemy->life -= 5;
			if(enemy->life > 0) {
				vx = fidiv(fadd(enemy->x, mychar.x), 2);
				vy = fidiv(fadd(enemy->y, mychar.y), 2);
				addeffect(
					vx,
					vy,
					fld(0.0),
					fld(0.0),
					fld(0.0),
					fld(96.0),
					EFFECT_TYPE_PERTIC1);
				addpertics(
					vx,
					vy,
					fld(64.0),
					fld(32.0),
					fld(0.0),
					fld(0.0),
					15);
			} else {
				destroypertics(
					enemy->x,
					enemy->y,
					enemy->sx,
					enemy->sy,
					enemy->type);
				delenemy(enemy);
			}

			ds_play(SND_MISS);
			break; /* ܂ */
		}
	LOOP_ENEMY()
}

/****************************************************************************
 *	moveanchor
 ****************************************************************************/

void
moveanchor()
{
	fixed vx;
	fixed vy;
	fixed rr;
	fixed vxx;
	fixed vyy;

	if(fcom(anchor.x, <, fld(  0.0))) anchor.x = fld(  0.0);
	if(fcom(anchor.x, >, fld(640.0))) anchor.x = fld(640.0);
	if(fcom(anchor.y, <, fld(  0.0))) anchor.y = fld(  0.0);
	if(fcom(anchor.y, >, fld(480.0))) anchor.y = fld(480.0);

	// o[xNg(vx,vy)
	vx = fld(0.0);
	vy = fld(0.0);
	if(joy & PAD_LF) vx = fld(-1.0);
	if(joy & PAD_UP) vy = fld(-1.0);
	if(joy & PAD_RI) vx = fld( 1.0);
	if(joy & PAD_DN) vy = fld( 1.0);

	// X^oC
	if(anchor.state == ANCHOR_STATE_STANDBY) {
		// ړĂꍇ̓AJ[Ɍ
		if(vx || vy) {
			rr = fatan2(vy, vx);
			fsub_(mychar.anc_rotate, rr);
			ROUND_PI2_(mychar.anc_rotate);
			fadd_(mychar.anc_rotate, rr);
			mychar.anc_rotate = fadd(fmul(mychar.anc_rotate, fisubr(ANCHOR_ROT_SP, 1)),
						 fmul(               rr,        ANCHOR_ROT_SP    ));
		}

		anchor.sx = fld(0.0);
		anchor.sy = fld(0.0);
		anchor.x = fadd(mychar.x, fmul(fld(40.0), fcos(mychar.anc_rotate)));
		anchor.y = fadd(mychar.y, fmul(fld(40.0), fsin(mychar.anc_rotate)));
		anchor.rotate = mychar.anc_rotate;

		// ˏo
		if(joy & TRG_A) {
			anchor.state = ANCHOR_STATE_THROW;
			anchor.sx = fmul(ANCHOR_SHOT_SP, fcos(mychar.anc_rotate));
			anchor.sy = fmul(ANCHOR_SHOT_SP, fsin(mychar.anc_rotate));

			mychar.sx = fmul(fchs(anchor.sx), ANCHOR_REACT_FORCE);
			mychar.sy = fmul(fchs(anchor.sy), ANCHOR_REACT_FORCE);

			ds_play(SND_ANCHOR_SHOT);
			return; /* ܂ */
		}
	}

	// 
	if(anchor.state == ANCHOR_STATE_THROW) {
		fadd_(anchor.x, anchor.sx);
		fadd_(anchor.y, anchor.sy);

		vxx = fsub(anchor.x, mychar.x);
		vyy = fsub(anchor.y, mychar.y);
		if(vx || vy) {
			fadd_(anchor.sx, fmul(vx, ANCHOR_SHOT_CONTROL));
			fadd_(anchor.sy, fmul(vy, ANCHOR_SHOT_CONTROL));
			rr = fsqrt(fadd(fmul(anchor.sx, anchor.sx), fmul(anchor.sy, anchor.sy)));
			if(rr) {
				anchor.sx = fdiv(fmul(anchor.sx, ANCHOR_SHOT_SP), rr);
				anchor.sy = fdiv(fmul(anchor.sy, ANCHOR_SHOT_SP), rr);
			}
			anchor.rotate = fatan2(vyy, vxx);
		}

		if(!(joy & PAD_A) ||
		   fcom(anchor.x, >, fld(640.0)) || fcom(anchor.x, <, fld(0.0)) ||
		   fcom(anchor.y, >, fld(480.0)) || fcom(anchor.y, <, fld(0.0)) ||
		   fcom(fsqrt(fadd(fmul(vxx, vxx), fmul(vyy, vyy))), >, ANCHOR_LENGTH_LIMIT)) {
			anchor.state = ANCHOR_STATE_RETURN;
		}
	}

	// ͂ݏ
	if(anchor.state == ANCHOR_STATE_GRAB) {
		fadd_(anchor.sx, fmul(ANCHOR_GRAB_SP, vx));
		fadd_(anchor.sy, fmul(ANCHOR_GRAB_SP, vy));
		fmul_(anchor.sx, ANCHOR_GRAB_SPWEAKEN);
		fmul_(anchor.sy, ANCHOR_GRAB_SPWEAKEN);

		fadd_(anchor.x, anchor.sx);
		fadd_(anchor.y, anchor.sy);

		vxx = fsub(anchor.x, mychar.x);
		vyy = fsub(anchor.y, mychar.y);
		rr = fsqrt(fadd(fmul(vxx, vxx), fmul(vyy, vyy)));
		if(fcom(rr, <, fld(20.0))) {
			if(rr) {
				anchor.x = fadd(mychar.x, fdiv(fmul(fld(20.0), vxx), rr));
				anchor.y = fadd(mychar.y, fdiv(fmul(fld(20.0), vyy), rr));
			}
			fmul_(anchor.sx, fld(0.8));
			fmul_(anchor.sy, fld(0.8));
		} else if(fcom(rr, >, ANCHOR_LENGTH_LIMIT)) {
			anchor.x = fadd(mychar.x, fdiv(fmul(ANCHOR_LENGTH_LIMIT, vxx), rr));
			anchor.y = fadd(mychar.y, fdiv(fmul(ANCHOR_LENGTH_LIMIT, vyy), rr));
		}

		rr = anchor.rotate;
		anchor.rotate = fatan2(vyy, vxx);
		fadd_(grab_enemy.rotate, fsub(anchor.rotate, rr));
		ROUND_PI2_(grab_enemy.rotate);

		grab_enemy.x = fadd(anchor.x, fmul(fidiv(fadd(ANCHOR_SIZE, enemy_spec[grab_enemy.type].size), 2), fcos(anchor.rotate)));
		grab_enemy.y = fadd(anchor.y, fmul(fidiv(fadd(ANCHOR_SIZE, enemy_spec[grab_enemy.type].size), 2), fsin(anchor.rotate)));

		// 
		if(!(joy & PAD_A)) {
			anchor.state = ANCHOR_STATE_RETURN;

			vxx = fadd(anchor.sx, fmul(ANCHOR_THROW_SP, fcos(anchor.rotate)));
			vyy = fadd(anchor.sy, fmul(ANCHOR_THROW_SP, fsin(anchor.rotate)));

			addthrenemy(
				grab_enemy.x,
				grab_enemy.y,
				vxx,
				vyy,
				grab_enemy.rotate,
				grab_enemy.type,
				grab_enemy.life);

			ds_play(SND_ANCHOR_GRAB);
		}
	}

	// 
	if(anchor.state == ANCHOR_STATE_RETURN) {
		vxx = fsub(anchor.x, mychar.x);
		vyy = fsub(anchor.y, mychar.y);
		rr = fsqrt(fadd(fmul(vxx, vxx), fmul(vyy, vyy)));
		if(rr) {
			anchor.sx = fdiv(fmul(fchs(ANCHOR_RETURN_SP), vxx), rr);
			anchor.sy = fdiv(fmul(fchs(ANCHOR_RETURN_SP), vyy), rr);
		}
		anchor.rotate = fatan2(vyy, vxx);

		fadd_(anchor.x, anchor.sx);
		fadd_(anchor.y, anchor.sy);

		if(fcom(rr, <, fld(32.0))) {
			mychar.sx = fmul(anchor.sx, ANCHOR_REACT_FORCE);
			mychar.sy = fmul(anchor.sy, ANCHOR_REACT_FORCE);
			mychar.anc_rotate = fatan2(vyy, vxx);
			anchor.state = ANCHOR_STATE_STANDBY;

			ds_play(SND_ANCHOR_RETURN);
		}
	}

	// AJ[ƓG̏Փ------------------------------
	REPEAT_ENEMY()
		vxx = fsub(anchor.x, enemy->x);
		vyy = fsub(anchor.y, enemy->y);
		rr = fadd(ANCHOR_SIZE, enemy_spec[enemy->type].size);
		if(fcom(fadd(fmul(vxx, vxx), fmul(vyy, vyy)), <, fmul(rr, rr))) {
			// G̗͂1Ȃ
			if(enemy->life < 1) {
				destroypertics(
					enemy->x,
					enemy->y,
					enemy->sx,
					enemy->sy,
					enemy->type);
				delenemy(enemy);
				continue; /* ܂ */
			}
			// ݂͂ɍs
			if(anchor.state == ANCHOR_STATE_THROW) {
				// GXRAœG̗͂ꍇ͎s
				if((enemy->life > CATCHABLE_BORDER) && enemy_spec[enemy->type].score) {
					enemy->life--; // Gɏ_[W
					anchor.state = ANCHOR_STATE_RETURN;
					addpertics(
						fsub(anchor.x, fidiv(vxx, 2)),
						fsub(anchor.y, fidiv(vyy, 2)),
						fld(32.0),
						fld(32.0),
						fld(0.0),
						fld(0.0),
						8);
					ds_play(SND_BLOCK);
					break; /* ܂ */
				}
				// AJ[H
				anchor.state = ANCHOR_STATE_GRAB;
				anchor.sx = fidiv(enemy->sx, 2);
				anchor.sy = fidiv(enemy->sy, 2);
				grab_enemy.type = enemy->type;
				grab_enemy.x = enemy->x;
				grab_enemy.y = enemy->y;
				grab_enemy.rotate = enemy->rotate;
				grab_enemy.life = enemy_spec[enemy->type].life; // enemy->life
				delenemy(enemy);
				ds_play(SND_ANCHOR_GRAB);
				break; /* ܂ */
			}
			if(anchor.state == ANCHOR_STATE_STANDBY) {
				// ͂
				addeffect(
					fsub(anchor.x, fidiv(vxx, 2)),
					fsub(anchor.y, fidiv(vyy, 2)),
					fld(0.0),
					fld(0.0),
					RND_PI2(),
					fld(32.0),
					EFFECT_TYPE_PERTIC1);
				addpertics(
					fsub(anchor.x, fidiv(vxx, 2)),
					fsub(anchor.y, fidiv(vyy, 2)),
					fld(32.0),
					fld(32.0),
					fld(0.0),
					fld(0.0),
					3);
				//{{---
				//rr = sqrt(vxx * vxx + vyy * vyy);
				//̂悤ɌvẐƎv̂łA
				//̌vZ@ŃQ[oXĂ܂B
				rr = fsqrt(rr);
				//}}---
				if(rr) {
					fdiv_(vxx, rr);
					fdiv_(vyy, rr);
				}
				mychar.sx = fmul(MYCHAR_DAM_SP, vxx);
				mychar.sy = fmul(MYCHAR_DAM_SP, vyy);
				ds_play(SND_BLOCK);
				break; /* ܂ */
			}
		}
	LOOP_ENEMY()

	if(anchor.state == ANCHOR_STATE_THROW) {
		REPEAT_THRENEMY()
			vxx = fsub(anchor.x, threnemy->x);
			vyy = fsub(anchor.y, threnemy->y);
			rr = fadd(ANCHOR_SIZE, enemy_spec[threnemy->type].size);
			if(fcom(fadd(fmul(vxx, vxx), fmul(vyy, vyy)), <, fmul(rr, rr))) {
				// AJ[H
				anchor.state = ANCHOR_STATE_GRAB;
				anchor.sx = fidiv(threnemy->sx, 2);
				anchor.sy = fidiv(threnemy->sy, 2);
				grab_enemy.type = threnemy->type;
				grab_enemy.x = threnemy->x;
				grab_enemy.y = threnemy->y;
				grab_enemy.rotate = threnemy->rotate;
				grab_enemy.life = threnemy->life;
				delthrenemy(threnemy);
				ds_play(SND_ANCHOR_GRAB);
				break; /* ܂ */
			}
		LOOP_THRENEMY()
	}
}

/****************************************************************************
 *	moveenemy
 ****************************************************************************/

void
moveenemy()
{
	int i;
	int j;
	int t;
	int ty;
	fixed vx;
	fixed vy;
	fixed rr;
	fixed sp;
	fixed r;

	// ʏ
	REPEAT_ENEMY()
		// 폜
		//if(fcom(enemy->x, <, fld(-128.0)) ||
		//   fcom(enemy->y, <, fld(-128.0)) || fcom(enemy->y, >, fld(480.0 + 128.0))) {
		//* Sat Feb 03 00:01:33 JST 2007 Naoyuki Sawa
		//- ʉEOւ̏ŏĂ܂B
		//  ꂪŁAXʉE֓Ƃɂ܂łłAvŽI[o[ŕsȓ蔻肪Ă܂B
		//  IWił̏ŏĂ̂łAIWił͕ZȂ̂ŌI[o[ɂȂȂ݂łB
		if(fcom(enemy->x, <, fld(-128.0)) || fcom(enemy->x, >, fld(640.0 + 128.0)) ||
		   fcom(enemy->y, <, fld(-128.0)) || fcom(enemy->y, >, fld(480.0 + 128.0))) {
			delenemy(enemy);
			continue; /* ܂ */
		}
		vx = fsub(mychar.x, enemy->x);
		vy = fsub(mychar.y, enemy->y);
		rr = fatan2(vy, vx);
		switch(enemy->type) {
		// --------------------------------
		case ENEMY_TYPE_SHOT1:
		case ENEMY_TYPE_SHOT2:
			fadd_(enemy->x, enemy->sx);
			fadd_(enemy->y, enemy->sy);
			if(fcom(enemy->x, <, fld(-32.0)) || fcom(enemy->x, >, fld(640.0 + 32.0)) ||
			   fcom(enemy->y, <, fld(-32.0)) || fcom(enemy->y, >, fld(480.0 + 32.0))) {
				delenemy(enemy);
				continue; /* ܂ */
			}
			break;
		// |bL[卪-----------------------
		case ENEMY_TYPE_SHOT3:
		case ENEMY_TYPE_SHOT4:
			enemy->timer++;
			if(enemy->timer < 40) {
				fadd_(enemy->rotate, fld(0.3));
				ROUND_PI2_(enemy->rotate);
			} else {
				if(enemy->timer == 40) {
					enemy->rotate = rr;
				}
				sp = fadd(fmul(fld(level), fld(0.006)), fld(0.2));
				fadd_(enemy->sx, fmul(sp, fcos(enemy->rotate)));
				fadd_(enemy->sy, fmul(sp, fsin(enemy->rotate)));
			}
			fmul_(enemy->sx, fld(0.95));
			fmul_(enemy->sy, fld(0.95));
			fadd_(enemy->x, enemy->sx);
			fadd_(enemy->y, enemy->sy);
			if(fcom(enemy->x, <, fld(-32.0)) || fcom(enemy->x, >, fld(640.0 + 32.0)) ||
			   fcom(enemy->y, <, fld(-32.0)) || fcom(enemy->y, >, fld(480.0 + 32.0))) {
				delenemy(enemy);
				continue; /* ܂ */
			}
			break;
		// Ȃ--------------------------------
		case ENEMY_TYPE_ZAKO1:
			enemy->timer++;
			if(enemy->timer < 60) {
				fadd_(enemy->x, enemy->sx);
				fadd_(enemy->y, enemy->sy);
				fmul_(enemy->sx, fld(0.95));
				fmul_(enemy->sy, fld(0.95));
			}
			if(enemy->timer == 60) {
				if(fcom(enemy->y, <, fld(120.0)) || fcom(enemy->y, >, fld(360.0))) {
					if(fcom(enemy->x, <, fld(320.0))) {
						enemy->sx = fld(1.0);
						enemy->sy = fld(0.0);
					} else {
						enemy->sx = fld(-1.0);
						enemy->sy = fld( 0.0);
					}
				} else {
					if(fcom(enemy->y, <, fld(240.0))) {
						enemy->sx = fld(0.0);
						enemy->sy = fld(1.0);
					} else {
						enemy->sx = fld( 0.0);
						enemy->sy = fld(-1.0);
					}
				}
			}
			if((enemy->timer > 60) & (enemy->timer < 310)) {
				fadd_(enemy->x, enemy->sx);
				fadd_(enemy->y, enemy->sy);
				fadd_(enemy->x, fsin(fmul(fld(enemy->timer), fld(0.1))));
				fadd_(enemy->y, fcos(fmul(fld(enemy->timer), fld(0.1))));
				if(enemy->timer > 310 - level * 2) {
					fadd_(enemy->rotate, fld(0.1));
					ROUND_PI2_(enemy->rotate);
					if(!(enemy->timer % 10)) {
						rr = RND_PI2();
						addenemy(
							enemy->x,
							enemy->y,
							fmul(fld(4.0), fcos(rr)),
							fmul(fld(4.0), fsin(rr)),
							rr,
							ENEMY_TYPE_SHOT1);
					}
				}
			}
			if(enemy->timer > 309) {
				vx = fsub(enemy->x, fld(320.0));
				vy = fsub(enemy->y, fld(240.0));
				rr = fsqrt(fadd(fmul(vx, vx), fmul(vy, vy)));
				if(rr) {
					enemy->sx = fmul(fimul(fdiv(vx, rr), (enemy->timer - 310)), fld(0.1));
					enemy->sy = fmul(fimul(fdiv(vy, rr), (enemy->timer - 310)), fld(0.1));
				}
				fadd_(enemy->x, enemy->sx);
				fadd_(enemy->y, enemy->sy);
			}
			break;
		// Ă-----------------------------------
		case ENEMY_TYPE_ZAKO2:
			enemy->timer++;
			if(!(enemy->timer % 120)) {
				vx = fsub(mychar.x, enemy->x);
				vy = fsub(mychar.y, enemy->y);
				rr = fsqrt(fadd(fmul(vx, vx), fmul(vy, vy)));
				if(rr) {
					enemy->sx = fidiv(fimul(fdiv(vx, rr), (level + 48)), 12);
					enemy->sy = fidiv(fimul(fdiv(vy, rr), (level + 48)), 12);
				}
			} else {
				rr = fidiv(fld(enemy->timer % 120), 120);
				fadd_(enemy->x, enemy->sx);
				fadd_(enemy->y, enemy->sy);
				fmul_(enemy->sx, fld(0.95));
				fmul_(enemy->sy, fld(0.95));
				fadd_(enemy->rotate, fmul(rr, rr));
				ROUND_PI2_(enemy->rotate);
			}
			break;
		// ---------------------------------------
		case ENEMY_TYPE_BOX1:
		case ENEMY_TYPE_BOX2:
			fadd_(enemy->x, enemy->sx);
			fadd_(enemy->y, enemy->sy);
			break;
		// ---------------------------------------
		case ENEMY_TYPE_MID1:
			enemy->timer++;
			if(enemy->timer < 60) {
				fadd_(enemy->x, enemy->sx);
				fadd_(enemy->y, enemy->sy);
				fmul_(enemy->sx, fld(0.95));
				fmul_(enemy->sy, fld(0.95));
				enemy->flag = RND32(seed) & 7;
			}
			if(enemy->timer > 59) {
				enemy->sx = fld(0.0);
				enemy->sy = fld(0.0);
				fadd_(enemy->x, fmul(fsin(fmul(fld(enemy->timer), fld(0.05))), fld(0.25)));
				fadd_(enemy->y, fmul(fcos(fmul(fld(enemy->timer), fld(0.05))), fld(0.25)));
				if(fcom(enemy->x, <, fld(        32.0))) fadd_(enemy->x, fld(0.5));
				if(fcom(enemy->x, >, fld(640.0 - 32.0))) fsub_(enemy->x, fld(0.5));
				if(fcom(enemy->y, <, fld(        32.0))) fadd_(enemy->y, fld(0.5));
				if(fcom(enemy->y, >, fld(480.0 - 32.0))) fsub_(enemy->y, fld(0.5));
			}
			if(!(enemy->timer % 30)) {
				enemy->flag++;
				if(!(enemy->flag % 8)) { // 4way
					t = level / 8 + 1;
					for(i = 0; i < t; i++) {
						if(level < 20) {
							sp = fsub(fadd(fmul(fld(i), fld(0.7)), fld(2.8)), fimul(fld(0.1), level));
						} else {
							sp =      fadd(fmul(fld(i), fld(0.7)), fld(0.8));
						}
						addenemy(enemy->x, enemy->y, fmul(sp, fcos(fadd(rr, fmul(PI, fld(0.40))))),
									     fmul(sp, fsin(fadd(rr, fmul(PI, fld(0.40))))), fld(0.0), ENEMY_TYPE_SHOT1);
						addenemy(enemy->x, enemy->y, fmul(sp, fcos(fadd(rr, fmul(PI, fld(0.15))))),
									     fmul(sp, fsin(fadd(rr, fmul(PI, fld(0.15))))), fld(0.0), ENEMY_TYPE_SHOT1);
						addenemy(enemy->x, enemy->y, fmul(sp, fcos(fsub(rr, fmul(PI, fld(0.15))))),
									     fmul(sp, fsin(fsub(rr, fmul(PI, fld(0.15))))), fld(0.0), ENEMY_TYPE_SHOT1);
						addenemy(enemy->x, enemy->y, fmul(sp, fcos(fsub(rr, fmul(PI, fld(0.40))))),
									     fmul(sp, fsin(fsub(rr, fmul(PI, fld(0.40))))), fld(0.0), ENEMY_TYPE_SHOT1);
					}
					ds_play(SND_ENEMYSHOT);
				}
				if((enemy->flag % 8) == 4) { // ɂ񂶂Vbg
					sp = fadd(fld(6.0), fmul(fld(level), fld(0.06)));
					addenemy(
						enemy->x,
						enemy->y,
						fmul(sp, fcos(rr)),
						fmul(sp, fsin(rr)),
						rr,
						ENEMY_TYPE_SHOT2);
					t = level / 10;
					for(i = 0; i < t; i++) {
						r = fimul(fidiv(PI, 36), (i + 1));
						fmul_(sp, fld(0.8));
						addenemy(enemy->x, enemy->y, fmul(sp, fcos(fadd(rr, r))),
									     fmul(sp, fsin(fadd(rr, r))), fld(0.0), ENEMY_TYPE_SHOT1);
						addenemy(enemy->x, enemy->y, fmul(sp, fcos(fsub(rr, r))),
									     fmul(sp, fsin(fsub(rr, r))), fld(0.0), ENEMY_TYPE_SHOT1);
					}
					ds_play(SND_ENEMYSHOT);
				}
			}
			break;
		// v---------------------------------------
		case ENEMY_TYPE_MID2:
			enemy->timer++;
			if(enemy->timer == 1) {
				enemy->flag = RND32(seed) & 7;
			};
			if(!(enemy->timer % 120)) {
				sp = fadd(fld(4.0), fmul(fld(level), fld(0.1)));
				rr = RND_PI2();
				enemy->sx = fmul(sp, fcos(rr));
				enemy->sy = fmul(sp, fsin(rr));
			} else {
				if(fcom(enemy->x, <, fld(        32.0)) && fcom(enemy->sx, <, fld(0.0))) fmul_(enemy->sx, fld(-0.8));
				if(fcom(enemy->x, >, fld(640.0 - 32.0)) && fcom(enemy->sx, >, fld(0.0))) fmul_(enemy->sx, fld(-0.8));
				if(fcom(enemy->y, <, fld(        32.0)) && fcom(enemy->sy, <, fld(0.0))) fmul_(enemy->sy, fld(-0.8));
				if(fcom(enemy->y, >, fld(480.0 - 32.0)) && fcom(enemy->sy, >, fld(0.0))) fmul_(enemy->sy, fld(-0.8));
				fadd_(enemy->x, enemy->sx);
				fadd_(enemy->y, enemy->sy);
				fmul_(enemy->sx, fld(0.95));
				fmul_(enemy->sy, fld(0.95));
			}
			if(!(enemy->timer % 30)) {
				enemy->flag++;
				if(!(enemy->flag % 8)) { // 8΂T
					vx = enemy->x;
					vy = enemy->y;
					t = level / 7 + 1;
					for(i = 0; i < t; i++) {
						if(level < 20) {
							sp = fsub(fadd(fmul(fld(i), fld(0.6)), fld(2.8)), fimul(fld(0.1), level));
						} else {
							sp =      fadd(fmul(fld(i), fld(0.6)), fld(0.8));
						}
						if(i == (level / 7)) {
							ty = ENEMY_TYPE_SHOT2;
						} else {
							ty = ENEMY_TYPE_SHOT1;
						}
						for(j = 0; j < 8; j++) {
							rr = fimul(fidiv(PI, 4), j);
							if(!(j & 1) || (ty == ENEMY_TYPE_SHOT1)) {
								addenemy(
									vx,
									vy,
									fmul(sp, fcos(rr)),
									fmul(sp, fsin(rr)),
									rr,
									ty);
							}
						}
					}
					ds_play(SND_ENEMYSHOT);
				}
			}
			if(!(enemy->timer % 3) && ((enemy->timer % 60) < (level / 5 + 1))) {
				if((enemy->flag % 8) == 4) { // 卪݂[
					sp = fadd(fld(8.0), fmul(fld(level), fld(0.08)));
					rr = RND_PI2();
					addenemy(
						enemy->x,
						enemy->y,
						fmul(sp, fcos(rr)),
						fmul(sp, fsin(rr)),
						rr,
						ENEMY_TYPE_SHOT4);
					ds_play(SND_ENEMYSHOT);
				}
			}
			break;
		}
	LOOP_ENEMY()

	// 
	REPEAT_THRENEMY()
		// j
		if(fcom(threnemy->x, <, fld(0.0)) || fcom(threnemy->x, >, fld(640.0)) ||
		   fcom(threnemy->y, <, fld(0.0)) || fcom(threnemy->y, >, fld(480.0))) {
			destroypertics(
				threnemy->x,
				threnemy->y,
				fld(0.0),
				fld(0.0),
				threnemy->type);
			addscore(enemy_spec[threnemy->type].score);
			delthrenemy(threnemy);
			continue; /* ܂ */
		}
		fadd_(threnemy->x, threnemy->sx);
		fadd_(threnemy->y, threnemy->sy);
		fadd_(threnemy->sy, THROWN_DROP_SP);
		fadd_(threnemy->rotate, fld(0.05));
		ROUND_PI2_(threnemy->rotate);
	LOOP_THRENEMY()
}

/****************************************************************************
 *	geneenemy
 ****************************************************************************/

void
geneenemy()
{
	int t;
	fixed rr;
	fixed vx;
	fixed vy;
	fixed xxx;
	fixed yyy;
	fixed dx;
	fixed dy;

	// UR
	t = 0;
	REPEAT_ENEMY()
		if(enemy->type > ENEMY_TYPE_SHOT4) t++;	// GeȊOJEg
	LOOP_ENEMY()
	//
	if((!(play_timer % (30 + (level % 5) * 12)) && ((level % 10    ) > 4)) ||
	   (!(play_timer % (20                   )) && ((level / 10 + 2) > t))) {
		rr = RND_PI2();
		vx = fsin(rr);
		vy = fcos(rr);
		xxx = fsub(fld(320.0), fmul(fld(352.0), vx));
		yyy = fsub(fld(240.0), fmul(fld(352.0), vy));
		fimul_(vx, 6);
		fimul_(vy, 6);
		//
		dx = fsub(mychar.x, xxx);
		dy = fsub(mychar.y, yyy);
		rr = fsqrt(fadd(fmul(dx, dx), fmul(dy, dy)));
		if(fcom(rr, >, ENEMYGENE_NONECRASH)) {
			if((level % 4) < 2) {
				addenemy(xxx, yyy, vx, vy, fld(0.0), ENEMY_TYPE_ZAKO1);
			} else {
				addenemy(xxx, yyy, vx, vy, fld(0.0), ENEMY_TYPE_ZAKO2);
			}
		}
	}

	// 
	if(!(play_timer % 60) && !(RND32(seed) & 7)) {
		if(!RND32_RANGE(seed, 0, 5)) {
			addenemy(fld(  0.0 - 32.0), fld(  0.0 + 32.0), fld( 4.0), fld(0.0), fld(0.0), ENEMY_TYPE_BOX2);
		} else {
			addenemy(fld(640.0 + 32.0), fld(480.0 - 32.0), fld(-2.0), fld(0.0), fld(0.0), ENEMY_TYPE_BOX1);
		}
	}

	// ^
	if(!(play_timer % (295 - (level % 5) * 40)) && ((level % 5) > 1)) {
		t = 0;
		REPEAT_ENEMY()
			if((enemy->type == ENEMY_TYPE_MID1) || (enemy->type == ENEMY_TYPE_MID2)) t++;	// ^JEg
		LOOP_ENEMY()
		//
		if(t < ((level + 6) / 10)) {
			rr = RND_PI2();
			vx = fsin(rr);
			vy = fcos(rr);
			xxx = fsub(fld(320.0), fmul(fld(352.0), vx));
			yyy = fsub(fld(240.0), fmul(fld(352.0), vy));
			fimul_(vx, 8);
			fimul_(vy, 8);
			//
			dx = fsub(mychar.x, xxx);
			dy = fsub(mychar.y, yyy);
			rr = fsqrt(fadd(fmul(dx, dx), fmul(dy, dy)));
			if(fcom(rr, >, ENEMYGENE_NONECRASH)) {
				if((level < 6) || !(RND32(seed) & 1)) {
					addenemy(xxx, yyy, vx, vy, fld(0.0), ENEMY_TYPE_MID1);
				} else {
					addenemy(xxx, yyy, vx, vy, fld(0.0), ENEMY_TYPE_MID2);
				}
			}
		}
	}
}

/****************************************************************************
 *	fdrawenemy
 ****************************************************************************/

void
fdrawenemy(fixed xx, fixed yy, fixed rot, int tp)
{
	switch(tp) {
	case ENEMY_TYPE_SHOT1: gcopy  (SPR_SHOT1,    xx, yy     ); break; // e
	case ENEMY_TYPE_SHOT2: grotate(SPR_SHOT2_00, xx, yy, rot); break; // jW
	case ENEMY_TYPE_SHOT3: grotate(SPR_SHOT3_00, xx, yy, rot); break; // |bL[
	case ENEMY_TYPE_SHOT4: grotate(SPR_SHOT4_00, xx, yy, rot); break; // 卪
	case ENEMY_TYPE_ZAKO1: grotate(SPR_ZAKO1_00, xx, yy, rot); break; // Ȃ
	case ENEMY_TYPE_ZAKO2: grotate(SPR_ZAKO2_00, xx, yy, rot); break; // Ă
	case ENEMY_TYPE_BOX1:  grotate(SPR_BOX1_00,  xx, yy, rot); break; // 5
	case ENEMY_TYPE_BOX2:  grotate(SPR_BOX2_00,  xx, yy, rot); break; // X
	case ENEMY_TYPE_MID1:  grotate(SPR_MID1_00,  xx, yy, rot); break; // 
	case ENEMY_TYPE_MID2:  grotate(SPR_MID2_00,  xx, yy, rot); break; // v
	}
}

/****************************************************************************
 *	drawmychar
 ****************************************************************************/

void
drawmychar()
{
	int spr;

	// ͂łG
	if(anchor.state == ANCHOR_STATE_GRAB) {
		fdrawenemy(
			grab_enemy.x,
			grab_enemy.y,
			grab_enemy.rotate,
			grab_enemy.type);
	}

	// AJ[
	if((anchor.state == ANCHOR_STATE_THROW) || (anchor.state == ANCHOR_STATE_RETURN)) {
		spr = SPR_ANCHOR2_00;
	} else {
		spr = SPR_ANCHOR1_00;
	}
	grotate(spr,
		anchor.x,
		anchor.y,
		anchor.rotate);

	// @
	if(mychar.dam_timer || ((mychar.life < MYCHAR_LIFE_BRINK) && (play_timer % 10 < 5))) {
		if(mychar.dam_timer) mychar.dam_timer--;
		spr = SPR_MYCHAR3_00;
	} else {
		if((play_timer / 6) & 1) {
			spr = SPR_MYCHAR2_00;
		} else {
			spr = SPR_MYCHAR1_00;
		}
	}
	grotate(spr,
		mychar.x,
		mychar.y,
		mychar.gr_rotate);

	// @Ct
	if(mychar.life < MYCHAR_LIFE_MAX) {
		int x = fist(fmul(mychar.x, fld(128.0 / 640.0))) - 4;
		int y = fist(fmul(mychar.y, fld( 88.0 / 480.0))) - 8;
		int n = (11 * mychar.life + (MYCHAR_LIFE_MAX - 1)) / MYCHAR_LIFE_MAX;
		render_rectangle_fill(&render, x - 1, y - 1, 11 + 2, 3, 3);
		render_rectangle_fill(&render, x    , y    ,      n, 1, 0);
		render_rectangle_fill(&render, x + n, y    , 11 - n, 1, 2);
	}
}

/****************************************************************************
 *	drawchain
 ****************************************************************************/

void
drawchain()
{
	int i;
	fixed vx;
	fixed vy;

	// AJ[`F[
	vx = fsub(mychar.x, anchor.x);
	vy = fsub(mychar.y, anchor.y);
	for(i = 0; i < ANCHOR_CHAIN_NUM; i++) {
		gcopy(
			SPR_CHAIN,
			fsub(mychar.x, fidiv(fimul(vx, i), ANCHOR_CHAIN_NUM)),
			fsub(mychar.y, fidiv(fimul(vy, i), ANCHOR_CHAIN_NUM)));
	}
}

/****************************************************************************
 *	drawenemy
 ****************************************************************************/

void
drawenemy()
{
	REPEAT_ENEMY()
		// ͂߂ȂGɂ̓Ot(̗͈ȏ&XRAt)
		if((enemy->life > CATCHABLE_BORDER) && enemy_spec[enemy->type].score) {
			int x = fist(fmul(enemy->x, fld(128.0 / 640.0)));
			int y = fist(fmul(enemy->y, fld( 88.0 / 480.0)));
			int color = abs(play_timer / 4/**/ % 6 - 3); /* 3,2,1,0,1,2 */
			sprite_draw(x, y, SPR_CIRCLE, DRW_CLR(color, COLOR_MASK));
		}
		fdrawenemy(
			enemy->x,
			enemy->y,
			enemy->rotate,
			enemy->type);
	LOOP_ENEMY()

	REPEAT_THRENEMY()
		fdrawenemy(
			threnemy->x,
			threnemy->y,
			threnemy->rotate,
			threnemy->type);
	LOOP_THRENEMY()
}

/****************************************************************************
 *	drawbanana
 ****************************************************************************/

void
drawbanana()
{
	REPEAT_EFFECT()
		if((effect->type == EFFECT_TYPE_BANANA) &&
		  ((effect->timer < EFFECT_LIVETIME / 2) || !(effect->timer & 1))) {
			gcopy(
				(effect->timer & 2) ? SPR_BANANA2 : SPR_BANANA1,
				effect->x,
				effect->y);
			fadd_(effect->sy, THROWN_DROP_SP);
		}
	LOOP_EFFECT()
}

/****************************************************************************
 *	movedraweffect
 ****************************************************************************/

void
movedraweffect()
{
	static const unsigned char clr_tbl[4/*alpha*/][4/*now&3*/] = {
		{ 3,4,3,4 },
		{ 2,4,2,4 },
		{ 1,3,1,3 },
		{ 0,2,0,2 },
	};
	//
	int i;
	int x;
	int y;
	int spr;
	int color;
	fixed r;
	fixed sz;

	REPEAT_EFFECT()
		if(effect->type == EFFECT_TYPE_BANANA) goto L_NEXT;	// ΂ȂȂ͍揇̊֌Wŕʈ

		i = 256 * (EFFECT_LIVETIME - effect->timer) / EFFECT_LIVETIME;
		if(effect->type == EFFECT_TYPE_LINE) i -= 128;
		i /= 64;
		if(i < 0) goto L_NEXT;
		if(i > 3) i = 3;
		color = clr_tbl[i][now & 3];
		if(color > 3) goto L_NEXT;

		switch(effect->type) {
		case EFFECT_TYPE_LINE:
			r = effect->rotate;
			fadd_(r, fld(M_PI2 / 32 / 2));
			fmul_(r, fld(32 / M_PI2    ));
			i = fist(r);
			i &= 15/*EFF30`3F*/;
			spr = SPR_EFF30_04 + i * 16/*EFF3x_04`64*/;
			break;
		//case EFFECT_TYPE_PERTIC1:
		//case EFFECT_TYPE_PERTIC2:
		//case EFFECT_TYPE_RING:
		default:
			if(effect->type == EFFECT_TYPE_RING) {
				spr = SPR_EFF2_02;
			} else {
				spr = SPR_EFF1_02;
			}
			break;
		}

		switch(effect->type) {
		case EFFECT_TYPE_PERTIC1:
		case EFFECT_TYPE_LINE:
			sz = fidiv(fld(EFFECT_LIVETIME - effect->timer + 5), EFFECT_LIVETIME);
			fmul_(sz, sz);
			fmul_(sz, effect->size);
			if(effect->type == EFFECT_TYPE_LINE) fimul_(sz, 2);
			break;
		//case EFFECT_TYPE_PERTIC2:
		//case EFFECT_TYPE_RING:
		default:
			sz = fidiv(fld(EFFECT_LIVETIME - effect->timer    ), EFFECT_LIVETIME);
			fmul_(sz, sz);
			fisubr_(sz, 1);
			fmul_(sz, effect->size);
			break;
		}
		sz = ffabs(fmul(sz, fld(128.0 / 640.0)));
		switch(effect->type) {
		case EFFECT_TYPE_LINE:
			for(i = 0; i < 16 - 1; i++) {
				fisub_(sz, 4);
				if(ficom(sz, <=, 0)) break;
			}
			break;
		//case EFFECT_TYPE_PERTIC1:
		//case EFFECT_TYPE_PERTIC2:
		//case EFFECT_TYPE_RING:
		default:
			for(i = 0; i < 32 - 1; i++) {
				fisub_(sz, 2);
				if(ficom(sz, <=, 0)) break;
			}
			break;
		}
		spr += i;

		x = fist(fmul(effect->x, fld(128.0 / 640.0)));
		y = fist(fmul(effect->y, fld( 88.0 / 480.0)));
		sprite_draw(x, y, spr, DRW_CLR(color, COLOR_MASK));

L_NEXT:
		fadd_(effect->x, effect->sx);
		fadd_(effect->y, effect->sy);
		fmul_(effect->sx, EFFECT_SPWEAKEN);
		fmul_(effect->sy, EFFECT_SPWEAKEN);

		effect->timer++;
		if(effect->timer > EFFECT_LIVETIME) {
			deleffect(effect);
		}
	LOOP_EFFECT()
}
